<!-- src/views/guest/Dashboard.vue -->
<template>
  <Navbar />
  <div>
    <div class="topMovies">
      <h1><span style="color:yellow">▏</span> Top Movies By Rating</h1>
      <p>We present top film with the best ratings based on reviews</p>
      
      <div v-if="topRatedFilms.length">
        <div style="display: flex;">
          <!-- Top 1 -->
          <iframe class="top-1" width="800" height="450" :src="topRatedFilms[0].trailer" title="YouTube video player" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share" referrerpolicy="strict-origin-when-cross-origin" allowfullscreen></iframe>
          <div class="top23">
            <!-- movie top 2 -->
            <div class="top2">
              <h4><b><span style="color:yellow">▏</span> Top <span style="color:yellow">Second</span> : {{ topRatedFilms[1].title }}</b></h4>
              <div class="video-content">
                <iframe width="267" height="150" :src="topRatedFilms[1].trailer" title="YouTube video player" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share" referrerpolicy="strict-origin-when-cross-origin" allowfullscreen></iframe>
                <div class="next">
                  <a href=""><img src="http://clipart-library.com/images_k/white-play-button-transparent/white-play-button-transparent-18.png" alt="" width="70px" height="70px"></a>
                  <div class="rating">
                    <p>⭐ {{ topRatedFilms[1].avg_rating }}</p> 
                  </div>
                </div>
              </div>
            </div>

            <!-- movie top 3 -->
            <div class="top3">
              <h4><b><span style="color:yellow">▏</span> Top <span style="color:yellow">Third</span> : {{ topRatedFilms[2].title }}</b></h4>
              <div class="video-content">
                <iframe width="267" height="150" :src="topRatedFilms[2].trailer" title="YouTube video player" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share" referrerpolicy="strict-origin-when-cross-origin" allowfullscreen></iframe>
                <div class="next">
                  <a href=""><img src="http://clipart-library.com/images_k/white-play-button-transparent/white-play-button-transparent-18.png" alt="" width="70px" height="70px"></a>
                  <div class="rating">
                    <p>⭐ {{ topRatedFilms[2].avg_rating }}</p> 
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
        
        <div class="top-information">
          <div class="inf">
            <p>⭐ {{ topRatedFilms[0].avg_rating }}</p>
            <p>{{ topRatedFilms[0].genre }}</p>
            <p>{{ topRatedFilms[0].min_rate }}</p>
          </div>
          <h1>{{ topRatedFilms[0].title }}</h1><br>
          <p>{{ topRatedFilms[0].synopsis }}</p>
        </div>
        
      </div>
      <div v-else>
        Loading top rated films...
      </div>
    </div>

    <!-- new upcoming movies -->
    <div class="newMovies container">
      <h1><span style="color:yellow">▏</span> All Movies</h1>
      <p>We present top film with the best ratings based on reviews</p>
      
      <div class="row row-cols-1 row-cols-md-6 g-4">
        <div v-for="film in dataResponse" :key="film.id">
          <div class="card" style="width: 200px; background-color:#1F2937; color:#ffffff">
            <router-link :to="{name: 'guest_detail', params:{id: film.id }}"><img :src="film.cover_image_url" :alt="film.title" style="width: 200px; height: 300px; padding:10px"></router-link>
            
            <div class="card-body">
              <h5 class="card-title">{{ film.title }}</h5>
              <p class="card-text" style="font-size:12px">
                {{ film.duration }} mnt • {{ film.genre }}
              </p>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
  
<script>
import Navbar from '@/components/Navbar.vue';
import axios from 'axios';
import { ref, watch } from 'vue';

export default {
  name: 'GuestDashboard',
  components: {
    Navbar
  },
  setup() {
    const URL = 'http://localhost:8000';

    const idDetail = ref(1);
    const dataResponse = ref([]);
    const topRatedFilms = ref([]);

    async function fetchDatas() {
      try {
        const response = await axios.get(`${URL}/api/dashboard`);
        dataResponse.value = response.data.films;
        topRatedFilms.value = response.data.topRatedFilms;
      } catch (err) {
        console.error(err);
      }
    }

    async function fetchMovieDetail(id) {
      try {
        const response = await axios.get(`${URL}/api/movie/${id}`);
        console.log(response);
      } catch (err) {
        console.error(err);
      }
    }

    fetchDatas();

    watch(idDetail, async (curr) => {
      console.log(curr);
      await fetchMovieDetail(curr);
    });

    return {
      idDetail,
      dataResponse,
      topRatedFilms
    };
  }
};
</script>
  
<style>
body {
    background: #030814;
}

div {
  color: white;
}

.topMovies {
  padding: 20px 115px;
  background-color: #111828;
}

.newMovies {
  margin-top: 20px;
  margin-bottom: 20px;
  background: #030814;
}

.top23 {
  margin-left: 20px;
}

.top3 {
  margin-top: 30px;
}

.video-content {
  padding: 10px;
  background-color: #151E2D;
  display: flex;
  border-radius: 10px;
}

.next {
  margin-top: 20px;
  padding: 0px 20px;
  justify-content: center;
}

.rating {
  margin-top: 20px;
}

.top-information {
  margin-top: 20px;
}

.top-information .inf p {
  background-color: #202938;
  padding: 5px 15px;
  margin-right: 20px;
  border-radius: 5px;
}

.top-information .inf{
  display: flex;
}

.card-title {
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
}
</style>
